package org.greenstone.gsdl3.gs3build.database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;

public class SQLConnection
{
    protected Connection connection;
    protected Statement  statement;


    public SQLConnection(java.sql.Connection connection)
    { 
	this.connection = connection;
    }
    
    protected void finalize() {
	if (this.connection!=null) {
	    try {
		this.connection.close();
	    } catch (Exception e) {}
	    
	    this.connection = null;
	}
    }
    
    public boolean execute(String sql)
    {
	try {
	    this.statement = this.connection.createStatement();
	    this.statement.execute(sql);
	}
	catch (SQLException ex) {
	    System.out.println(ex);
	    return false;
	}
	return true;
    }
    
    public Statement createStatement()
    { 
	try {
	    return this.connection.createStatement();
	}
	catch (SQLException ex) {
	    return null;
	}
    }
    
    public Statement getStatement()
    { 
	return this.statement;
    }
    
    public ResultSet getResultSet()
    { 
	try {
	    return this.statement.getResultSet();
	}
	catch (SQLException ex) {
	    return null;
	}
    }
    
    public boolean connectToDatabase(String database) {
	this.connection = GS3SQLConnectionFactory.getConnection(database);
	if (this.connection == null) {
	    return false;
	}
	return true;
    }
    
    public boolean dropDatabase(String database) {
	try {
	    this.statement = this.connection.createStatement();
	    this.statement.execute("DROP DATABASE "+database+";");
	}
	catch (SQLException ex){
	    System.err.println(ex);
	    return false;
	}
	return true;
	
    }

    public boolean createDatabase(String database) {
	try {
	    String command = "CREATE DATABASE " + database;
	    this.statement = this.connection.createStatement();
	    this.statement.execute(command);
	} catch (Exception e) {
	    System.err.println(e);
	    return false;
	}
	 
	return true;
    }

}
